diff --git a/drivers/base/attribute_container.c b/drivers/base/attribute_container.c
index b6f941a6ab69..d00c3d8d81d3 100644
--- a/drivers/base/attribute_container.c
+++ b/drivers/base/attribute_container.c
@@ -5,7 +5,7 @@
  * Copyright (c) 2005 - James Bottomley <James.Bottomley@steeleye.com>
  *
  * The basic idea here is to enable a device to be attached to an
- * aritrary numer of classes without having to allocate storage for them.
+ * arbitrary number of classes without having to allocate storage for them.
  * Instead, the contained classes select the devices they need to attach
  * to via a matching function.
  */
diff --git a/drivers/base/bus.c b/drivers/base/bus.c
index 657c93c38b0d..513183c3cab5 100644
--- a/drivers/base/bus.c
+++ b/drivers/base/bus.c
@@ -50,7 +50,7 @@ static int __must_check bus_rescan_devices_helper(struct device *dev,
  *
  * The driver core internals needs to work on the subsys_private structure, not
  * the external struct bus_type pointer.  This function walks the list of
- * registered busses in the system and finds the matching one and returns the
+ * registered buses in the system and finds the matching one and returns the
  * internal struct subsys_private that relates to that bus.
  *
  * Note, the reference count of the return value is INCREMENTED if it is not
@@ -1288,7 +1288,7 @@ EXPORT_SYMBOL_GPL(subsys_system_register);
  * @groups: default attributes for the root device
  *
  * All 'virtual' subsystems have a /sys/devices/system/<name> root device
- * with the name of the subystem.  The root device can carry subsystem-wide
+ * with the name of the subsystem.  The root device can carry subsystem-wide
  * attributes.  All registered devices are below this single root device.
  * There's no restriction on device naming.  This is for kernel software
  * constructs which need sysfs interface.
diff --git a/drivers/base/core.c b/drivers/base/core.c
index b69b82da8837..437444f2e064 100644
--- a/drivers/base/core.c
+++ b/drivers/base/core.c
@@ -1408,7 +1408,7 @@ void device_links_driver_bound(struct device *dev)
 
 /**
  * __device_links_no_driver - Update links of a device without a driver.
- * @dev: Device without a drvier.
+ * @dev: Device without a driver.
  *
  * Delete all non-persistent links from this device to any suppliers.
  *
diff --git a/drivers/base/cpu.c b/drivers/base/cpu.c
index fdaa24bb641a..97cdd0187da2 100644
--- a/drivers/base/cpu.c
+++ b/drivers/base/cpu.c
@@ -325,7 +325,7 @@ static void cpu_device_release(struct device *dev)
 	 * This is an empty function to prevent the driver core from spitting a
 	 * warning at us.  Yes, I know this is directly opposite of what the
 	 * documentation for the driver core and kobjects say, and the author
-	 * of this code has already been publically ridiculed for doing
+	 * of this code has already been publicaly ridiculed for doing
 	 * something as foolish as this.  However, at this point in time, it is
 	 * the only way to handle the issue of statically allocated cpu
 	 * devices.  The different architectures will have their cpu device
diff --git a/drivers/base/devcoredump.c b/drivers/base/devcoredump.c
index c795edad1b96..3ff01847a6d7 100644
--- a/drivers/base/devcoredump.c
+++ b/drivers/base/devcoredump.c
@@ -186,7 +186,7 @@ static ssize_t disabled_show(const struct class *class, const struct class_attri
  *             mutex_lock(&devcd->mutex);
  *
  *
- * In the above diagram, It looks like disabled_store() would be racing with parallely
+ * In the above diagram, It looks like disabled_store() would be racing with parallelly
  * running devcd_del() and result in memory abort while acquiring devcd->mutex which
  * is called after kfree of devcd memory  after dropping its last reference with
  * put_device(). However, this will not happens as fn(dev, data) runs
diff --git a/drivers/base/firmware_loader/main.c b/drivers/base/firmware_loader/main.c
index 324a9a3c087a..1aa509756d3e 100644
--- a/drivers/base/firmware_loader/main.c
+++ b/drivers/base/firmware_loader/main.c
@@ -1528,7 +1528,7 @@ static void __device_uncache_fw_images(void)
  * device_cache_fw_images() - cache devices' firmware
  *
  * If one device called request_firmware or its nowait version
- * successfully before, the firmware names are recored into the
+ * successfully before, the firmware names are recorded into the
  * device's devres link list, so device_cache_fw_images can call
  * cache_firmware() to cache these firmwares for the device,
  * then the device driver can load its firmwares easily at
diff --git a/drivers/base/power/clock_ops.c b/drivers/base/power/clock_ops.c
index e18ba676cdf6..36f4bc4cde41 100644
--- a/drivers/base/power/clock_ops.c
+++ b/drivers/base/power/clock_ops.c
@@ -250,7 +250,7 @@ EXPORT_SYMBOL_GPL(pm_clk_add);
  *
  * Add the clock to the list of clocks used for the power management of @dev.
  * The power-management code will take control of the clock reference, so
- * callers should not call clk_put() on @clk after this function sucessfully
+ * callers should not call clk_put() on @clk after this function successfully
  * returned.
  */
 int pm_clk_add_clk(struct device *dev, struct clk *clk)
diff --git a/drivers/base/regmap/regmap-spi-avmm.c b/drivers/base/regmap/regmap-spi-avmm.c
index d86a06cadcdb..67123e9db476 100644
--- a/drivers/base/regmap/regmap-spi-avmm.c
+++ b/drivers/base/regmap/regmap-spi-avmm.c
@@ -242,7 +242,7 @@ static int br_trans_tx_prepare(struct spi_avmm_bridge *br, bool is_read, u32 reg
  * before pad ...|7a|7c|00|10| |00|00|04|02| |4b|7d|5a|7b| |40|
  * after pad  ...|7a|7c|00|10| |00|00|04|02| |4b|7d|5a|4a| |4a|4a|7b|40|
  * Then if the slave will not get the entire packet before the tx phase is
- * over, it can't responsed to anything either.
+ * over, it can't respond to anything either.
  */
 static int br_pkt_phy_tx_prepare(struct spi_avmm_bridge *br)
 {
diff --git a/drivers/base/regmap/regmap-w1.c b/drivers/base/regmap/regmap-w1.c
index 29fd24f9c7ed..b0f39dd46c65 100644
--- a/drivers/base/regmap/regmap-w1.c
+++ b/drivers/base/regmap/regmap-w1.c
@@ -15,7 +15,7 @@
 #define W1_CMD_WRITE_DATA	0x6C
 
 /*
- * 1-Wire slaves registers with addess 8 bit and data 8 bit
+ * 1-Wire slaves registers with address 8 bit and data 8 bit
  */
 
 static int w1_reg_a8_v8_read(void *context, unsigned int reg, unsigned int *val)
@@ -63,7 +63,7 @@ static int w1_reg_a8_v8_write(void *context, unsigned int reg, unsigned int val)
 }
 
 /*
- * 1-Wire slaves registers with addess 8 bit and data 16 bit
+ * 1-Wire slaves registers with address 8 bit and data 16 bit
  */
 
 static int w1_reg_a8_v16_read(void *context, unsigned int reg,
@@ -115,7 +115,7 @@ static int w1_reg_a8_v16_write(void *context, unsigned int reg,
 }
 
 /*
- * 1-Wire slaves registers with addess 16 bit and data 16 bit
+ * 1-Wire slaves registers with address 16 bit and data 16 bit
  */
 
 static int w1_reg_a16_v16_read(void *context, unsigned int reg,
diff --git a/drivers/base/regmap/regmap.c b/drivers/base/regmap/regmap.c
index 9ed842d17642..79fc8e160215 100644
--- a/drivers/base/regmap/regmap.c
+++ b/drivers/base/regmap/regmap.c
@@ -2442,7 +2442,7 @@ static int _regmap_range_multi_paged_reg_write(struct regmap *map,
 	unsigned int this_page = 0;
 	unsigned int page_change = 0;
 	/*
-	 * the set of registers are not neccessarily in order, but
+	 * the set of registers are not necessarily in order, but
 	 * since the order of write must be preserved this algorithm
 	 * chops the set each time the page changes. This also applies
 	 * if there is a delay required at any point in the sequence.
@@ -2683,7 +2683,7 @@ EXPORT_SYMBOL_GPL(regmap_multi_reg_write_bypassed);
  * If supported by the underlying bus the write will be scheduled
  * asynchronously, helping maximise I/O speed on higher speed buses
  * like SPI.  regmap_async_complete() can be called to ensure that all
- * asynchrnous writes have been completed.
+ * asynchronous writes have been completed.
  *
  * A value of zero will be returned on success, a negative errno will
  * be returned in error cases.
diff --git a/drivers/base/transport_class.c b/drivers/base/transport_class.c
index 09ee2a1e35bb..ba4ef4dd4779 100644
--- a/drivers/base/transport_class.c
+++ b/drivers/base/transport_class.c
@@ -7,7 +7,7 @@
  *
  * The basic idea here is to allow any "device controller" (which
  * would most often be a Host Bus Adapter to use the services of one
- * or more tranport classes for performing transport specific
+ * or more transport classes for performing transport specific
  * services.  Transport specific services are things that the generic
  * command layer doesn't want to know about (speed settings, line
  * condidtioning, etc), but which the user might be interested in.